#include "fxlib.h"
#include "MonochromeLib.h"
#include "Serial.h"
#include "BetterFont.h"
#include "ChessLin.h"

static const unsigned char exit[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcc, 0x1, 0xff, 0xff, 0xff, 0xfc, 0x7f, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcc, 0x0, 0x7f, 0xff, 0xff, 0xfc, 0x7f, 0xe1, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcc, 0x0, 0x3f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcc, 0x7c, 0x1f, 0xff, 0xff, 0xfc, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x1f, 0x81, 0xf1, 0xc, 0x7c, 0x63, 0xc7, 0xc7, 0x10, 0xf0, 0x3c, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0xe, 0x0, 0xf0, 0xc, 0x78, 0xe3, 0xc7, 0xc7, 0x0, 0xc0, 0x1c, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x8e, 0x0, 0x70, 0xc, 0x71, 0xe3, 0xc7, 0xc7, 0x0, 0xc0, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x8e, 0x7c, 0x70, 0xfc, 0x63, 0xe3, 0xc7, 0xc7, 0xf, 0xcf, 0x8c, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x8f, 0xfc, 0x71, 0xfc, 0x47, 0xe3, 0xc7, 0xc7, 0x1f, 0xff, 0x8c, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x8f, 0x80, 0x71, 0xfc, 0xf, 0xe3, 0xc7, 0xc7, 0x1f, 0xf0, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x8e, 0x0, 0x71, 0xfc, 0x7, 0xe3, 0xc7, 0xc7, 0x1f, 0xc0, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0xc, 0x1c, 0x71, 0xfc, 0x43, 0xe3, 0xc7, 0xc7, 0x1f, 0x83, 0x8c, 0xff, 0xff, 0xff, 0xcc, 0x7f, 0x1c, 0x7c, 0x71, 0xfc, 0x63, 0xe3, 0xc7, 0xc7, 0x1f, 0x8f, 0x8c, 0xff, 0xff, 0xff, 0xcc, 0x7c, 0x1c, 0x78, 0x71, 0xfc, 0x71, 0xe3, 0xc3, 0x87, 0x1f, 0x8f, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x0, 0x3c, 0x0, 0x71, 0xfc, 0x70, 0xe3, 0xc0, 0x7, 0x1f, 0x80, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x0, 0x7e, 0x0, 0x71, 0xfc, 0x78, 0x63, 0xe0, 0x7, 0x1f, 0xc0, 0xc, 0xff, 0xff, 0xff, 0xcc, 0x1, 0xff, 0x4, 0x71, 0xfc, 0x7c, 0x63, 0xf0, 0xc7, 0x1f, 0xe0, 0x8c, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x83, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x87, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xcf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xff, 0xff, 0xff, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x7, 0xff, 0xff, 0x83, 0xf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x3, 0xff, 0xfe, 0x2, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x1, 0xff, 0xfe, 0x1e, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0xc1, 0xf8, 0x3c, 0x2, 0x4, 0x30, 0xc3, 0xe0, 0x3c, 0x47, 0x3, 0xf0, 0x1f, 0xff, 0xff, 0xe1, 0xff, 0xe0, 0x18, 0x0, 0x4, 0x30, 0xc3, 0x80, 0x18, 0x6, 0x1, 0xe0, 0x1f, 0xff, 0xff, 0xe0, 0x3f, 0xc0, 0x18, 0x4, 0xc, 0x20, 0x87, 0x0, 0x18, 0xc, 0x1, 0xc3, 0xf, 0xff, 0xff, 0xf0, 0xf, 0x86, 0x1c, 0x3c, 0x3c, 0x60, 0x8f, 0xc, 0x18, 0x78, 0x61, 0xc3, 0xff, 0xff, 0xff, 0xf8, 0x7, 0xe, 0x18, 0x78, 0x7c, 0x0, 0xf, 0xf8, 0x30, 0xf0, 0x1, 0x80, 0x7f, 0xff, 0xff, 0xff, 0x7, 0xe, 0x18, 0x78, 0x7c, 0x8, 0x1f, 0x80, 0x30, 0xf0, 0x1, 0xc0, 0x3f, 0xff, 0xff, 0xff, 0x87, 0xc, 0x38, 0x78, 0x7c, 0x18, 0x3e, 0x1c, 0x30, 0xf0, 0xff, 0xf0, 0x3f, 0xff, 0xff, 0x87, 0xe, 0xc, 0x30, 0xf0, 0xfc, 0x18, 0x3c, 0x38, 0x61, 0xe0, 0xc3, 0xfc, 0x3f, 0xff, 0xff, 0x80, 0x1f, 0x0, 0x70, 0xf0, 0x3c, 0x38, 0x7c, 0x0, 0x61, 0xf0, 0x7, 0xc, 0x3f, 0xff, 0xff, 0x80, 0x3f, 0x0, 0xf0, 0xf0, 0x7c, 0x78, 0x7c, 0x8, 0x61, 0xf0, 0xf, 0x0, 0x7f, 0xff, 0xff, 0xe0, 0x7f, 0x83, 0xe1, 0xf0, 0x78, 0xf8, 0xfe, 0x18, 0xc3, 0xf8, 0x3f, 0x81, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
static const unsigned char cheval[]={0x11,0x39,0xdd,0xfd,0x1d,0x39,0x7d,};
static const unsigned char dame[]={0x31,0x49,0x31,0x79,0x31,0x79,0xfd,};
static const unsigned char fou[]={0x21,0x69,0x69,0x31,0x79,0x31,0x79,};
static const unsigned char pion[]={0x1,0x31,0x79,0x79,0x31,0x79,0xfd,};
static const unsigned char roi[]={0x11,0x39,0x11,0x11,0x39,0x7d,0x7d,};
static const unsigned char tour[]={0x1,0x55,0x55,0x7d,0x39,0x39,0x7d,};
static char rr,Joueur,xclignote=99,yclignote=99,EstCeQueLeRoiABouge=0,EstCeQueLaTourABouge[2]={0,0},pointsPerdusNoirs=0,pointsPerdusBlancs=0,monchar,PriseEnPassant=15;

int AddIn_main(int isAppli,unsigned short OptionNum){
	unsigned int key;
	char i,j,x=1,y=1;
	tableau plateau[8];
	unsigned char config[]={0,5,0,0,0,0};

	Joueur=start();
	if(Joueur!=2)
	{
		rr=Joueur;
		initialiserTableau(plateau);

		Serial_Open(config);
		SetQuitHandler(FermerLePort3Pin);

		do
		{
			key=0;
			if(Joueur==0) CEstAToiDeJouer(&x,&y,plateau,&key);

			else if(Joueur==1)
			{
				afficherJeu(plateau,0,0,0);
				ML_display_vram();
				monchar=0;
				do
				{
					Serial_ReadByte(&monchar);
					if(IsKeyDown(KEY_CTRL_EXIT)) key=KEY_CTRL_EXIT;
				}while((monchar==0)&&(key!=KEY_CTRL_EXIT));
				if(key!=KEY_CTRL_EXIT)
				{
					Sleep(96);
					for(i=0;i<8;i++) for(j=0;j<8;j++) Serial_ReadByte(&plateau[i].a[j]);
					Serial_ReadByte(&xclignote);
					Serial_ReadByte(&yclignote);
					if(rr) Serial_ReadByte(&pointsPerdusNoirs);
					else Serial_ReadByte(&pointsPerdusBlancs);
					Serial_ReadByte(&PriseEnPassant);
					xclignote=-xclignote+58;
					yclignote=-yclignote+58;
				}
			}
			if(key!=KEY_CTRL_EXIT)
			{
				Joueur++;
				if(Joueur==2) Joueur=0;
			}
		}while((key!=KEY_CTRL_EXIT)||(EsTuSurDeVouloirQuitter()==0));
		Serial_Close(0);
	}
	ML_clear_vram();
	ML_bmp_or(exit,0,0,128,64);
	while(1){
		GetKey(&key);
	}
	return 1;
}

int EsTuSurDeVouloirQuitter(void){
	char x=78;
	unsigned int key;
	ML_rectangle(20,18,106,46,1,ML_BLACK,ML_WHITE);
	dispStr("Es-tu sur de vouloir",24,20);
	dispStr("quitter ?",50,28);
	dispStr("oui        non",38,36);
	ML_rectangle(35,35,50,43,1,ML_BLACK,ML_TRANSPARENT);
	ML_rectangle(78,35,93,43,1,ML_BLACK,ML_TRANSPARENT);
	SaveDisp(SAVEDISP_PAGE1);
	do
	{
		ML_rectangle(x,35,x+14,43,1,ML_BLACK,ML_XOR);
		GetKey(&key);
		ML_clear_vram();
		RestoreDisp(SAVEDISP_PAGE1);
		if(key==KEY_CTRL_RIGHT) x=78;
		else if(key==KEY_CTRL_LEFT) x=36;
	}while(key!=KEY_CTRL_EXE);
	if(x==36) return 1;
	return 0;
}
int start(void){
	const unsigned char MainMenu[]={0x1, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1, 0xc0, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1, 0xc1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1, 0xc3, 0x0, 0x6, 0x0, 0x0, 0x0, 0x1, 0x81, 0x80, 0x19, 0x8f, 0x1, 0xc0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x1, 0x81, 0x80, 0x19, 0x8f, 0x1, 0xc1, 0xe1, 0xe6, 0x1, 0xe1, 0xe7, 0x81, 0x80, 0x1e, 0x19, 0x8f, 0x1, 0xc1, 0xe1, 0xe6, 0x1, 0xe1, 0xe7, 0x81, 0x80, 0x1e, 0x19, 0x8f, 0x1, 0xc6, 0x66, 0x7, 0x86, 0x66, 0x6, 0x1, 0x81, 0x99, 0x9e, 0xf, 0x1, 0xc6, 0x66, 0x7, 0x86, 0x66, 0x6, 0x1, 0x81, 0x99, 0x9e, 0xf, 0x1, 0xc7, 0x86, 0x6, 0x67, 0x86, 0x1, 0x81, 0x81, 0x99, 0x99, 0x8f, 0x1, 0xc7, 0x86, 0x6, 0x67, 0x86, 0x1, 0x81, 0x81, 0x99, 0x99, 0x8f, 0x1, 0xc1, 0xe1, 0xe6, 0x61, 0xe1, 0xe7, 0x81, 0xf9, 0x99, 0x99, 0x8f, 0x1, 0xc1, 0xe1, 0xe6, 0x61, 0xe1, 0xe7, 0x81, 0xf9, 0x99, 0x99, 0x8f, 0x1, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x70, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x26, 0x7, 0x33, 0xb3, 0xb1, 0x9c, 0x73, 0x0, 0x0, 0x0, 0x0, 0x1, 0x29, 0x8, 0x4a, 0x4a, 0x4a, 0x52, 0x84, 0x80, 0x0, 0x0, 0x0, 0x1, 0x2f, 0x8, 0x4a, 0x4a, 0x4b, 0xd2, 0x87, 0x80, 0x0, 0x0, 0x0, 0x1, 0x28, 0x8, 0x4a, 0x4a, 0x4a, 0x12, 0x84, 0x0, 0x0, 0x0, 0x0, 0x1, 0xa7, 0x7, 0x32, 0x4a, 0x49, 0xd2, 0x73, 0x80, 0x0, 0x0, 0x0, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xd8, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xa9, 0x9c, 0x1c, 0x64, 0x30, 0x39, 0x9d, 0x9d, 0x8c, 0xe3, 0x98, 0x1, 0xaa, 0x52, 0x12, 0x94, 0x48, 0x42, 0x52, 0x52, 0x52, 0x94, 0x24, 0x1, 0xaa, 0x52, 0x12, 0x94, 0x78, 0x42, 0x52, 0x52, 0x5e, 0x94, 0x3c, 0x1, 0x8a, 0x52, 0x12, 0x94, 0x40, 0x42, 0x52, 0x52, 0x50, 0x94, 0x20, 0x1, 0x89, 0x92, 0x1c, 0x63, 0x38, 0x39, 0x92, 0x52, 0x4e, 0x93, 0x9c, 0x1, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, };
	unsigned int key;
	do
	{
		ML_bmp_or(MainMenu,15,1,95,48);
		if(Joueur==0)
		{
			ML_rectangle(13,23,74,36,1,ML_BLACK,ML_XOR);
			ML_pixel(13,23,ML_WHITE);
			ML_pixel(13,36,ML_WHITE);
			ML_pixel(74,23,ML_WHITE);
			ML_pixel(74,36,ML_WHITE);
		}
		if(Joueur)
		{
			ML_rectangle(13,37,104,50,1,ML_BLACK,ML_XOR);
			ML_pixel(13,37,ML_WHITE);
			ML_pixel(13,50,ML_WHITE);
			ML_pixel(104,37,ML_WHITE);
			ML_pixel(104,50,ML_WHITE);
		}
		GetKey(&key);
		ML_clear_vram();
		if(key==KEY_CTRL_UP) Joueur=0;
		if(key==KEY_CTRL_DOWN) Joueur=1;
	}while((key!=KEY_CTRL_EXE)&&(key!=KEY_CTRL_EXIT));
	if(key==KEY_CTRL_EXIT) Joueur=2;
	return Joueur;
}
void initialiserTableau(tableau gr[]){
	char i,j;
	gr[0].a[0]=4;
	gr[0].a[1]=2;
	gr[0].a[2]=3;
	if(rr)
	{
		gr[0].a[3]=6;
		gr[0].a[4]=5;
	}
	else
	{
		gr[0].a[3]=5;
		gr[0].a[4]=6;
	}
	gr[0].a[5]=3;
	gr[0].a[6]=2;
	gr[0].a[7]=4;
	for(i=0;i<8;i++) gr[1].a[i]=1;
	for(i=2;i<6;i++) for(j=0;j<8;j++) gr[i].a[j]=0;
	for(i=0;i<8;i++) gr[6].a[i]=-1;
	for(i=0;i<8;i++) gr[7].a[i]=-(gr[0].a[i]);
	if(rr) for(i=0;i<8;i++) for(j=0;j<8;j++) gr[i].a[j]=-(gr[i].a[j]);
	
}
void afficherJeu(tableau gr[],char a,char xx,char yy){
	char i,j,k,str[3]="";
	ML_clear_vram();
	for(i=0;i<65;i+=8)
	{
		ML_horizontal_line(i,0,63,ML_BLACK);
		ML_vertical_line(i,0,63,ML_BLACK);
	}

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
			k=gr[i].a[j];
			if(abs(k)==1) ML_bmp_or(pion,8*j+1,8*i+1,7,7);
			if(abs(k)==2) ML_bmp_or(cheval,8*j+1,8*i+1,7,7);
			if(abs(k)==3) ML_bmp_or(fou,8*j+1,8*i+1,7,7);
			if(abs(k)==4) ML_bmp_or(tour,8*j+1,8*i+1,7,7);
			if(abs(k)==5) ML_bmp_or(dame,8*j+1,8*i+1,7,7);
			if(abs(k)==6) ML_bmp_or(roi,8*j+1,8*i+1,7,7);
			if(k<0) ML_rectangle(8*j+1,8*i+1,8*j+7,8*i+7,1,ML_XOR,ML_XOR);
		}
	}
	if(a) ML_rectangle(xx,yy,xx+6,yy+6,1,ML_XOR,ML_XOR);
	if(rr==0)
	{
		if(Joueur) dispStr("BLACK to play",67,0);
		if(Joueur==0) dispStr("WHITE to play",67,0);
	}
	else
	{
		if(Joueur==0) dispStr("BLACK to play",67,0);
		if(Joueur) dispStr("WHITE to play",67,0);
	}
	itoa(pointsPerdusBlancs,str);
	dispStr("Blancs :",67,20);
	dispStr(str,98,20);
	itoa(pointsPerdusNoirs,str);
	dispStr("Noirs :",67,29);
	dispStr(str,95,29);
	if(EstCeQuIlYAEchecAuRoi(gr,0,0,0))
	{
		dispStr("Echec au roi",68,45);
		ML_rectangle(66,44,115,52,1,ML_BLACK,ML_TRANSPARENT);
	}
}
int EstCeQueJePeuxSelectionnerCetteCase(char x,char y,tableau gr[]){
	if(rr==0) if(gr[(y-1)/8].a[(x-1)/8]<0) return 1;
	if(rr) if(gr[(y-1)/8].a[(x-1)/8]>0) return 1;
	return 0;
}
void CEstAToiDeJouer(char*ax,char*ay,tableau gr[],unsigned int*key){
	char xx,yy,x,y,a;
	x=*ax;
	y=*ay;
	afficherJeu(gr,0,0,0);
	SaveDisp(SAVEDISP_PAGE1);
	do
	{
		ML_clear_vram();
		RestoreDisp(SAVEDISP_PAGE1);
		if(((*key==0)&&((xclignote!=x)||(yclignote!=y)))||(*key)) ML_rectangle(x,y,x+6,y+6,1,ML_BLACK,ML_TRANSPARENT);
		if(*key==0) SetTimer(1,400,clignote);
		GetKey(key);
		KillTimer(1);
		if(*key==KEY_CTRL_DOWN) y+=8;
		if(*key==KEY_CTRL_RIGHT) x+=8;
		if(*key==KEY_CTRL_UP) y-=8;
		if(*key==KEY_CTRL_LEFT) x-=8;
		if(x==-7) x=57;
		if(y==-7) y=57;
		if(x==65) x=1;
		if(y==65) y=1;
		if((*key==KEY_CTRL_EXE)&&(EstCeQueJePeuxSelectionnerCetteCase(x,y,gr))) break;
	}while(*key!=KEY_CTRL_EXIT);
	if(*key==KEY_CTRL_EXE)
	{
		xx=x;
		yy=y;
		afficherJeu(gr,1,xx,yy);
		SaveDisp(SAVEDISP_PAGE1);
		do
		{
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE1);
			ML_rectangle(x,y,x+6,y+6,1,ML_BLACK,ML_TRANSPARENT);
			GetKey(key);
			if(*key==KEY_CTRL_DOWN) y+=8;
			if(*key==KEY_CTRL_RIGHT) x+=8;
			if(*key==KEY_CTRL_UP) y-=8;
			if(*key==KEY_CTRL_LEFT) x-=8;
			if(x==-7) x=57;
			if(y==-7) y=57;
			if(x==65) x=1;
			if(y==65) y=1;
			if((*key==KEY_CTRL_EXE)&&(a=EstCeQueJePeuxMeDeplacerSurCetteCase(&xx,&yy,x,y,gr))) if((MetsAJourLaGrille(xx,yy,x,y,gr))) break;
		}while(*key!=KEY_CTRL_EXIT);
		if(*key==KEY_CTRL_EXE)
		{
			if(a==1) PriseEnPassant=15; 
			if(EstCeQueLaTourABouge[0]==0) if(abs(gr[7].a[0])!=4) EstCeQueLaTourABouge[0]=1;
			if(EstCeQueLaTourABouge[1]==0) if(abs(gr[7].a[7])!=4) EstCeQueLaTourABouge[1]=1;
			if(EstCeQueLeRoiABouge==0)
			{
				if(rr==0) if(gr[7].a[4]!=-6) EstCeQueLeRoiABouge=1;
				if(rr) if(gr[7].a[3]!=6) EstCeQueLeRoiABouge=1;
			}
			Serial_WriteByte(3);
			for(xx=7;xx>=0;xx--) for(yy=7;yy>=0;yy--) Serial_WriteByte(gr[xx].a[yy]);
			Serial_WriteByte(x);
			Serial_WriteByte(y);
			if(rr==0) Serial_WriteByte(pointsPerdusNoirs);
			if(rr) Serial_WriteByte(pointsPerdusBlancs);
			Serial_WriteByte(PriseEnPassant);
		}
		*ax=x;
		*ay=y;
	}
}
int EstCeQueJePeuxMeDeplacerSurCetteCase(char*xx,char*yy,char x,char y,tableau gr[]){
	char caseDeDepart,caseDArrivee,XX,YY,X,Y,i,ii,j=1,str[3]="";
	
	unsigned int key;
	
	YY=(*yy-1)/8;		// coordonnées de la case de départ (YY & XX)
	XX=(*xx-1)/8;
	Y=(y-1)/8;			// coordonnées de la case d'arrivée ( Y & X )
	X=(x-1)/8;
	caseDArrivee=gr[Y].a[X];
	caseDeDepart=gr[YY].a[XX];

	if(((rr==0)&&(caseDArrivee<0))||((rr)&&(caseDArrivee>0)))			// Si tu as reséléctionné une de tes propres pièces ...
	{
		*xx=x;																// alors on change la case sélectionnée.
		*yy=y;
		afficherJeu(gr,1,x,y);												// et on réaffiche le plateau
		SaveDisp(SAVEDISP_PAGE1);
		return 0;
	}
	
	if(abs(caseDeDepart)==1)														// Si tu essayes de bouger un pion ...
	{
		if((Y==4)&&(YY==6)&&(XX==X)&&(gr[YY-1].a[X]==0)&&(caseDArrivee==0))				// Tu avances de 2 cases
		{
			PriseEnPassant=abs(X-7);
			return 2;
		}
		if((YY-Y==1)&&(XX==X)&&(caseDArrivee==0)) return 1;								// Tu avances de 1 case
		if((abs(XX-X)==1)&&(YY-Y==1))													// Si tu avance de 1 case en diagonale
		{
			if(caseDArrivee!=0) return 1;													// Tu manges un pion adverse
			if((caseDArrivee==0)&&(PriseEnPassant==X))										// Prise en passant !
			{
				gr[YY].a[X]=0;
				
				itoa(PriseEnPassant,str);
				dispStr(str,66,55);
				GetKey(&key);
				
				return 1;
			}
		}
	}
	if(abs(caseDeDepart)==2)														// Si tu essayes de bouger un cavalier ...
	{
		if((abs(XX-X)==1)&&(abs(YY-Y)==2)) return 1;									// 'L' vertical droite ou gauche
		if((abs(XX-X)==2)&&(abs(YY-Y)==1)) return 1;									// 'L' horizontal droite ou gauche
	}
	if(abs(caseDeDepart)==6)														// Si tu essayes de bouger le roi ...
	{
		if((abs(XX-X)<=1)&&(abs(YY-Y)<=1)) return 1;									// Tu peux tant que caseDeDepart est à côté de caseDArrivee
		if(EstCeQueLeRoiABouge==0)														// Si le roi n'a pas bougé ...
		{
			if(rr==0)																		// Si on a les blancs en première ligne
			{
				if(X==2)																		// Grand roc ...
				{
					if((gr[7].a[1]==0)&&(gr[7].a[2]==0)&&(gr[7].a[3]==0))							// Si les cases entre la tour et le roi sont vides ...
					{
						if((!EstCeQuIlYAEchecAuRoi(gr,1,3,7))&&(!EstCeQuIlYAEchecAuRoi(gr,0,0,0)))		// Si le roi ne passe pas par une case où il est en échec
						{
							if(EstCeQueLaTourABouge[0]==0)													// Si la tour concernée n'a pas encore bougée
							{
								gr[7].a[3]=-4;																	// On bouge la tour
								gr[7].a[0]=0;
								return 1;
							}
						}
					}
				}
				else if(X==6)																		// petit roc ...
				{
					if((gr[7].a[5]==0)&&(gr[7].a[6]==0))											// Si les cases entre la tour et le roi sont vides ...
					{
						if((!EstCeQuIlYAEchecAuRoi(gr,1,5,7))&&(!EstCeQuIlYAEchecAuRoi(gr,0,0,0)))		// Si le roi ne passe pas par une case où il est en échec
						{
							if(EstCeQueLaTourABouge[1]==0)													// Si la tour concernée n'a pas encore bougée
							{
								gr[7].a[5]=-4;																	// On bouge la tour
								gr[7].a[7]=0;
								return 1;
							}
						}
					}
				}
			}
			else																			// Si on a les noirs en première ligne
			{
				if(X==5)																		// Grand roc ...
				{
					if((gr[7].a[4]==0)&&(gr[7].a[5]==0)&&(gr[7].a[6]==0))							// Si les cases entre la tour et le roi sont vides ...
					{
						if((!EstCeQuIlYAEchecAuRoi(gr,1,4,7))&&(!EstCeQuIlYAEchecAuRoi(gr,0,0,0)))		// Si le roi ne passe pas par une case où il est en échec
						{
							if(EstCeQueLaTourABouge[1]==0)													// Si la tour concernée n'a pas encore bougée
							{
								gr[7].a[4]=4;																	// On bouge la tour
								gr[7].a[7]=0;
								return 1;
							}
						}
					}
				}
				else if(X==1)																		// petit roc ...
				{
					if((gr[7].a[1]==0)&&(gr[7].a[2]==0))											// Si les cases entre la tour et le roi sont vides ...
					{
						if((!EstCeQuIlYAEchecAuRoi(gr,1,2,7))&&(!EstCeQuIlYAEchecAuRoi(gr,0,0,0)))		// Si le roi ne passe pas par une case où il est en échec
						{
							if(EstCeQueLaTourABouge[0]==0)													// Si la tour concernée n'a pas encore bougée
							{
								gr[7].a[2]=4;																	// On bouge la tour
								gr[7].a[0]=0;
								return 1;
							}
						}
					}
				}
			}
		}
	}
	if((abs(caseDeDepart)==4)||(abs(caseDeDepart)==5))									// Si tu essayes de bouger une tour (ou la dame)...
	{
		if(YY==Y)																			// Déplacement horizontal
		{
			if(X<XX) for(i=XX-1;i>X;i--) if(gr[Y].a[i]!=0) j=0;									// vers la gauche
			if(X>XX) for(i=XX+1;i<X;i++) if(gr[Y].a[i]!=0) j=0;									// vers la droite
			if(j) return 1;
		}
		if(XX==X)																			// Déplacement vertical
		{
			if(Y<YY) for(i=YY-1;i>Y;i--) if(gr[i].a[X]!=0) j=0;									// vers le haut
			if(Y>YY) for(i=YY+1;i<Y;i++) if(gr[i].a[X]!=0) j=0;									// vers le bas
			if(j) return 1;
		}
	}
	if((abs(caseDeDepart)==3)||(abs(caseDeDepart)==5))										// Si tu essayes de bouger un fou (ou la dame)...
	{
		if(abs(YY-Y)==abs(XX-X))																// Si tu l'as bougé en diagonale
		{
			if((X<XX)&&(Y<YY)) for(i=XX-1,ii=YY-1;i>X,ii>Y;i--,ii--) if(gr[ii].a[i]!=0) j=0;		// Haut Gauche
			if((X>XX)&&(Y<YY)) for(i=XX+1,ii=YY-1;i<X,ii>Y;i++,ii--) if(gr[ii].a[i]!=0) j=0;		// Haut Droit
			if((X<XX)&&(Y>YY)) for(i=XX-1,ii=YY+1;i>X,ii<Y;i--,ii++) if(gr[ii].a[i]!=0) j=0;		// Bas Gauche
			if((X>XX)&&(Y>YY)) for(i=XX+1,ii=YY+1;i<X,ii<Y;i++,ii++) if(gr[ii].a[i]!=0) j=0;		// Bas Droit
			if(j) return 1;
		}
	}

	return 0;
}
int RechercherRoi(tableau g[],char*i,char*j){
	for((*i)=0;(*i)<8;(*i)++)
	{
		for((*j)=0;(*j)<8;(*j)++)
		{
			if(rr==0) if(g[(*i)].a[(*j)]==-6) return 1;
			if(rr) if(g[(*i)].a[(*j)]==6) return 1;
		}
	}
}
int MetsAJourLaGrille(char xdepart,char ydepart,char xarrivee,char yarrivee,tableau grille[]){
	char i,j,a=0;
	tableau grilleN2[8];
	for(i=0;i<8;i++) for(j=0;j<8;j++) grilleN2[i].a[j]=grille[i].a[j];
	xdepart=(xdepart-1)/8;
	ydepart=(ydepart-1)/8;
	xarrivee=(xarrivee-1)/8;
	yarrivee=(yarrivee-1)/8;
	grille[yarrivee].a[xarrivee]=grille[ydepart].a[xdepart];
	grille[ydepart].a[xdepart]=0;
	if(EstCeQuIlYAEchecAuRoi(grille,0,0,0))
	{
		for(i=0;i<8;i++) for(j=0;j<8;j++) grille[i].a[j]=grilleN2[i].a[j];
		return 0;
	}
	for(i=0;i<8;i++)
	{
		if(abs(grille[0].a[i])==1) grille[0].a[i]*=5;					// verification des pions qui deviennent des dames sur la première ligne
		if(abs(grille[7].a[i])==1) grille[7].a[i]*=5;					// verification des pions qui deviennent des dames sur la dernière ligne
	}

	for(i=0;i<8;i++)
	{
		for(j=0;j<8;j++)
		{
			if(rr) if(grille[i].a[j]<0) a+=Points(grille[i].a[j]);
			if(rr==0) if(grille[i].a[j]>0) a+=Points(grille[i].a[j]);
		}
	}
	a=39-a;
	if(rr==0) pointsPerdusNoirs=a;
	else pointsPerdusBlancs=a;

	return 1;
}
int EstCeQuIlYAEchecAuRoi(tableau g[],char a,char xRoi,char yRoi){
	char i,j,color=-1;
	if(a==0) RechercherRoi(g,&yRoi,&xRoi);
	if(rr==0) color=1;
	for(i=xRoi-1;i>=0;i--)															// Test de la ligne horizontale gauche
	{
		if(g[yRoi].a[i]!=0)																// Si la case n'est pas vide ...
		{
			if((g[yRoi].a[i]==color*4)||(g[yRoi].a[i]==color*5)) return 1;					// Tu peux pas déplacer ton pion si c'est une tour ou la dame ennemie
			break;
		}
	}
	for(i=xRoi+1;i<8;i++)															// Test de la ligne horizontale droite
	{
		if(g[yRoi].a[i]!=0)																// Si la case n'est pas vide ...
		{
			if((g[yRoi].a[i]==color*4)||(g[yRoi].a[i]==color*5)) return 1;					// Tu peux pas déplacer ton pion si c'est une tour ou la dame ennemie
			break;
		}
	}
	for(i=yRoi-1;i>=0;i--)															// Test de la ligne verticale haut
	{
		if(g[i].a[xRoi]!=0)																// Si la case n'est pas vide ...
		{
			if((g[i].a[xRoi]==color*4)||(g[i].a[xRoi]==color*5)) return 1;					// Tu peux pas déplacer ton pion si c'est une tour ou la dame ennemie
			break;
			}
	}
	for(i=yRoi+1;i<8;i++)															// Test de la ligne verticale bas
	{
		if(g[i].a[xRoi]!=0)																// Si la case n'est pas vide ...
		{
			if((g[i].a[xRoi]==color*4)||(g[i].a[xRoi]==color*5)) return 1;					// Tu peux pas déplacer ton pion si c'est une tour ou la dame ennemie
			break;
		}
	}
	for(i=xRoi-1,j=yRoi-1;i>=0,j>=0;i--,j--)										// Test de la diagonale haut gauche
	{
		if(g[j].a[i]!=0)																// Si la case n'est pas vide
		{
			if((g[j].a[i]==color*3)||(g[j].a[i]==color*5)) return 1;						// Tu peux pas déplacer ton pion si c'est un fou ou la dame ennemie
			break;
		}
	}
	for(i=xRoi+1,j=yRoi-1;i<8,j>=0;i++,j--)											// Test de la diagonale haut droite
	{
		if(g[j].a[i]!=0)																// Si la case n'est pas vide
		{
			if((g[j].a[i]==color*3)||(g[j].a[i]==color*5)) return 1;						// Tu peux pas déplacer ton pion si c'est un fou ou la dame ennemie
			break;
		}
	}
	for(i=xRoi-1,j=yRoi+1;i>=0,j<8;i--,j++)											// Test de la diagonale bas gauche
	{
		if(g[j].a[i]!=0)																// Si la case n'est pas vide
		{
			if((g[j].a[i]==color*3)||(g[j].a[i]==color*5)) return 1;						// Tu peux pas déplacer ton pion si c'est un fou ou la dame ennemie
			break;
		}
	}
	for(i=xRoi+1,j=yRoi+1;i<8,j<8;i++,j++)											// Test de la diagonale bas droite
	{
		if(g[j].a[i]!=0)																// Si la case n'est pas vide
		{
			if((g[j].a[i]==color*3)||(g[j].a[i]==color*5)) return 1;						// Tu peux pas déplacer ton pion si c'est un fou ou la dame ennemie
			break;
		}
	}
	if((yRoi-1>=0)&&(xRoi-1>=0)) if(g[yRoi-1].a[xRoi-1]==color*1) return 1;			// Pion devant le roi (à gauche) : il est en échec !
	if((yRoi-1>=0)&&(xRoi+1<8)) if(g[yRoi-1].a[xRoi+1]==color*1) return 1;			// Pion devant le roi (à droite) : il est en échec !
	if((yRoi-2>=0)&&(xRoi-1>=0)) if(g[yRoi-2].a[xRoi-1]==color*2) return 1;			// Cavalier 'L' vertical haut gauche
	if((yRoi-2>=0)&&(xRoi+1<8)) if(g[yRoi-2].a[xRoi+1]==color*2) return 1;			// Cavalier 'L' vertical haut droite
	if((yRoi+2<8)&&(xRoi-1>=0)) if(g[yRoi+2].a[xRoi-1]==color*2) return 1;			// Cavalier 'L' vertical bas gauche
	if((yRoi+2<8)&&(xRoi+1<8)) if(g[yRoi+2].a[xRoi+1]==color*2) return 1;			// Cavalier 'L' vertical bas droite
	if((yRoi-1>=0)&&(xRoi-2>=0)) if(g[yRoi-1].a[xRoi-2]==color*2) return 1;			// Cavalier 'L' horizontal haut gauche
	if((yRoi-1>=0)&&(xRoi+2<8)) if(g[yRoi-1].a[xRoi+2]==color*2) return 1;			// Cavalier 'L' horizontal haut droite
	if((yRoi+1<8)&&(xRoi-2>=0)) if(g[yRoi+1].a[xRoi-2]==color*2) return 1;			// Cavalier 'L' horizontal bas gauche
	if((yRoi+1<8)&&(xRoi+2<8)) if(g[yRoi+1].a[xRoi+2]==color*2) return 1;			// Cavalier 'L' horizontal bas droite

	if((yRoi-1>=0)&&(xRoi-1>=0)) if(g[yRoi-1].a[xRoi-1]==color*6) return 1;			// Roi haut gauche
	if(yRoi-1>=0) if(g[yRoi-1].a[xRoi]==color*6) return 1;							// Roi haut milieu
	if((yRoi-1>=0)&&(xRoi+1<8)) if(g[yRoi-1].a[xRoi+1]==color*6) return 1;			// Roi haut droite
	if(xRoi-1>=0) if(g[yRoi].a[xRoi-1]==color*6) return 1;							// Roi milieu gauche
	if(xRoi+1<8) if(g[yRoi].a[xRoi+1]==color*6) return 1;							// Roi milieu droite
	if((yRoi+1<8)&&(xRoi-1>=0)) if(g[yRoi+1].a[xRoi-1]==color*6) return 1;			// Roi bas gauche
	if(yRoi+1<8) if(g[yRoi+1].a[xRoi]==color*6) return 1;							// Roi bas milieu
	if((yRoi+1<8)&&(xRoi+1<8)) if(g[yRoi+1].a[xRoi+1]==color*6) return 1;			// Roi bas droite
	
	return 0;
}

int Points(char a){
	if(abs(a)==1) return 1;
	if(abs(a)==2) return 3;
	if(abs(a)==3) return 3;
	if(abs(a)==4) return 5;
	if(abs(a)==5) return 9;
	return 0;
}
void clignote(void){
	if(ML_pixel_test(123,8)==ML_WHITE)
	{
		ML_rectangle(xclignote,yclignote,xclignote+6,yclignote+6,1,ML_XOR,ML_XOR);
		ML_display_vram();
	}
}
void FermerLePort3Pin(void){
	Serial_Close(0);
}
void itoa(int n, char s[]){
	int i,j,sign;
	char c;
	if((sign=n)<0) n=-n;
	i=0;
	do{
		s[i++]=n%10+'0';
	}while((n/=10)>0);
	if(sign<0)
	s[i++]='-';
	s[i]='\0';
	for(i=0,j=strlen(s)-1;i<j;i++,j--){
		c=s[i];
		s[i]=s[j];
		s[j]=c;
	}
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum){
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section